;================================================
;	ЂƂӂ
;	ver 1.01
;	for PC-G850 series
;	AASM 3.70
;	2006-08
;	by CHOI KYUN ikyuns@lily.freemail.ne.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	include "DEF.ASM"		;e`

	org	0100h




Init:
	call	Cls			;ʏ
	call	Init_KEY		;L[
	call	Init_LCDC		;LCDC
	call	Init_BEEP		;BEEP
	call	Randomize		;_}CY

	call	Print_Credit		;ҕ\
	call	ClearAllScreen

	call	InitHiScore		;nCXRA

	call	Title			;^Cg\



ReStart:
	call	InitValue		;eϐ
	call	InitScore		;XRA
	call	InitStatus		;Xe[^Xʏ
	call	InitMap			;}bv
	call	InitCursor		;J[\
	call	InitBlock		;ubN



Main:
	{
		call	Inkey		;L[

		call	ClearWindow	;Q[ʂ̃NA

		call	MoveCursor	;J[\ړ
		call	PutCursor	;J[\\

		call	ScrollUp	;XN[
		call	CheckLine	;
		call	ScrollBlock	;ubÑXN[
		call	MapToScreen	;XN[`

		call	Flash		;C̓_
		call	Print_LINE	;Xe[^XC,I[o[C`

		call	DispScreen	;XN[\

		call	LevelUp		;xAbv
		call	Pause		;|[Y
		call	GameOver	;Q[I[o[
		call	GameOver2
		call	ChangeSe	;ʉ̐؂芷

		in	a,(01fh)	;[BREAK]L[ŏI
		rlca
		jr	nc,continue
	}



Basic:
	call	Cls
	call	InfoVer_GAME		;o[W\
	call	InfoVer_LIB
	ret



;------------------------------------------------
;	^Cg\
;------------------------------------------------
Title:
	call	Print_TITLE
	call	Print_SE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jr	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	ClearAllScreen
	call	Sound2
	ret



Print_TITLE:
	ld	hl,Title_data
	ld	de,0*256+25		;X=25,Y=0..7
	{
		ld	bc,93
		call	PutBitmap

		ld	a,c
		add	a,l
		ld	l,a
	        adc	a,h
	        sub	l
		ld	h,a		;add hl,a

		inc	d
		ld	a,d
		cp	6
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	ϐ
;------------------------------------------------
InitValue:
	ld	a,DEF_CUR_WAIT		;J[\EFCg
	ld	(cur_wait),a

	ld	a,DEF_SCRL_WAIT		;XN[EFCg
	ld	(scrl_wait),a
	ld	(scrl_wait_def),a

	ld	a,7			;XN[hbg݃JEg
	ld	(scrl_count),a

	xor	a
	ld	(move_flg),a		;ړtO
	ld	(chain_count),a		;AJEg
	ld	(chain_start),a		;AJntO
	ld	(erase_count),a		;JEgixAbvj

	inc	a
	ld	(level),a		;x
	ret



;------------------------------------------------
;	tB[h}bv
;------------------------------------------------
InitMap:
	ld	hl,FieldMap
	ld	de,FieldMap+1
	ld	bc,MAP_WIDTH*MAP_HEIGHT-1
	ld	(hl),0
	ldir

	ld	hl,FlashMap
	ld	de,FlashMap+1
	ld	bc,MAP_WIDTH*2-1
	ld	(hl),0
	ldir

	ret



;------------------------------------------------
;	ʉ̐؂芷
;------------------------------------------------
ChangeSe:
	ld	a,(keyf)
	bit	KEY_CLS,a
	ret	z

	ld	a,(sound)
	xor	1
	ld	(sound),a

	ld	b,a
	add	a,a
	add	a,b
	rrca
	rrca				;00H or 0C0H
	ld	(_beep+1),a

	jp	Print_SE



;------------------------------------------------
;	J[\ʒu
;------------------------------------------------
InitCursor:
	ld	de,3*256+5		;X=5,Y=3
	ld	(cur_x),de
	jp	PutCursor
;	ret



;------------------------------------------------
;	XN[
;------------------------------------------------
ScrollUp:
	ld	a,(key)
	bit	KEY_SPC,a
	ret	z

	ld	a,1
	ld	(scrl_wait),a
	ret



;------------------------------------------------
;	ubN
;------------------------------------------------
InitBlock:
	ld	hl,FieldMap+DEF_START_POS	;ubNX^[gʒu
	ld	b,7			;7
	{
		call	Rnd
		and	7
		add	a,a
		add	a,a
		add	a,a
		add	a,a		;~16
		ld	e,a
		ld	d,0

		push	hl
		add	hl,de
		ld	(hl),MARK_BLOCK

		pop	hl
		inc	hl

		djnz	continue
	}
	ret



;------------------------------------------------
;	VubNZbg
;------------------------------------------------
PutNewBlock:
	ld	hl,FieldMap+12			;x=12

	call	Rnd
	and	7
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0

	add	hl,de
	ld	(hl),MARK_BLOCK
	ret



;------------------------------------------------
;	Xe[^Xʏ
;------------------------------------------------
InitStatus:
	call	Print_HI		;nCXRA
	call	Print_SC		;XRA
	call	Print_LV		;x
	call	Print_LINE		;C

	call	Print_SE		;ʉACR

	call	DispScore		;XRA\
	call	DispHiScore		;nCXRA\
	jp	DispLv			;x\
;	ret


Print_HI:
	ld	hl,Font_HI
	ld	de,0*256+103		;X=103,Y=0
	ld	bc,39
	jp	PutBitmap
;	ret


Print_SC:
	ld	hl,Font_SC
	ld	de,2*256+103		;X=103,Y=2
	ld	bc,39
	jp	PutBitmap
;	ret


Print_LV:
	ld	hl,Font_LV
	ld	de,4*256+103		;X=103,Y=4
	ld	bc,39
	jp	PutBitmap
;	ret


Print_SE:
	ld	a,(sound)
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,Icon_SE
	add	hl,de

	ld	de,5*256+136		;X=136,Y=5
	ld	bc,8
	jp	PutBitmap
;	ret


Print_LINE:
	ld	de,0*256+96		;X=96,Y=0..7
	{
		ld	hl,Font_LINE	;Xe[^Xʂ̃Cis͗lj
		ld	bc,7
		call	PutBitmap

		inc	d
		ld	a,d
		cp	6
		jr	nz,continue
	}
	ld	b,6
	ld	hl,ScreenBuf+8		;Q[I[o[C
	{
		ld	a,(hl)
		or	055h
		ld	(hl),a

		inc	h
		djnz	continue
	}
	ret



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
GameOver:
	ld	a,(scrl_count)
	or	a
	ret	nz

	ld	hl,FieldMap
	ld	de,MAP_WIDTH
	ld	b,MAP_HEIGHT
	{
		ld	a,(hl)
		add	hl,de
		or	a
		jr	nz,break

		djnz	continue
		ret
	}


_GameOver:
	ld	bc,1200
	call	Wait

	call	ClearWindow
	call	DrawOverBlock	;Q[I[o[̃ubN
	call	PutCursor
	call	MapToScreen
	call	Print_LINE
	call	DispScreen
	call	Sound5

	ld	bc,800
	call	Wait
	call	Print_OVER
	call	CmpHiscore	;nCXRA
	call	DispHiScore
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	Sound2
	pop	af
	jp	ReStart



Print_OVER:
	ld	hl,Font_OVER
	ld	de,2*256+10		;X=10,Y=2
	ld	bc,76
	call	PutBitmap

	ld	hl,Font_PUSH
	ld	de,5*256+30		;X=30,Y=5
	ld	bc,66
	jp	PutBitmap
;	ret



	;ubN
DrawOverBlock:
	ld	hl,FieldMap
	ld	b,MAP_WIDTH*MAP_HEIGHT
	{
		ld	a,(hl)
		{
			cp	MARK_BLOCK
			jr	nz,break
			inc	a
			ld	(hl),a
		}
		inc	hl
		djnz	continue
	}
	ret



;------------------------------------------------
;	ړs\̃Q[I[o[
;------------------------------------------------
GameOver2:
	call	GetCurPos
	push	hl
	pop	ix

	ld	a,(cur_y)
	or	a
	jr	z,_0
	cp	7
	jr	z,_7

	ld	a,(ix+1)	;E
	or	a
	ret	z
	ld	a,(ix+0ffh)	; -1
	or	a
	ret	z
	ld	a,(ix+0f0h)	; -MAP_WIDTH
	or	a
	ret	z
	ld	a,(ix+MAP_WIDTH);
	or	a
	ret	z

	jp	_gameover

_0:
	ld	a,(ix+1)	;E
	or	a
	ret	z
	ld	a,(ix+0ffh)	;
	or	a
	ret	z
	ld	a,(ix+MAP_WIDTH);
	or	a
	ret	z

	jp	_gameover

_7:
	ld	a,(ix+1)	;E
	or	a
	ret	z
	ld	a,(ix+0ffh)	;
	or	a
	ret	z
	ld	a,(ix+0f0h)	;
	or	a
	ret	z

	jp	_gameover



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
	ld	a,(keyf)
	bit	KEY_SHIFT,a
	ret	z
	call	Sound1
	call	Print_PAUSE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SHIFT,a
		jr	z,continue
	}
	call	Sound1
	ret



Print_PAUSE:
	ld	hl,Font_PAUSE
	ld	de,5*256+0		;X=0,Y=5
	ld	bc,21
	call	PutBitmap
	ret



;------------------------------------------------
;	xAbv
;------------------------------------------------
LevelUp:
	ld	a,(erase_count)
	cp	NEXT_LEVEL
	ret	c

	xor	a
	ld	(erase_count),a

	ld	a,(scrl_wait_def)
	sub	DEF_SCRL_WAIT/10
	ld	(scrl_wait_def),a

	ld	hl,level
	inc	(hl)
	call	DispLv
	jp	Sound6



;------------------------------------------------
;	J[\ړ
;------------------------------------------------
MoveCursor:
	ld	hl,cur_wait		;J[\ړEFCg
	dec	(hl)
	ret	nz

	ld	(hl),DEF_CUR_WAIT


_up:
	ld	a,(move_flg)		;_Œ͏㉺ړȂ
	or	a
	jr	nz,_down

	ld	a,(key)
	bit	KEY_8,a
	jr	z,_down

	ld	a,(cur_y)
	cp	1
	ret	c

	call	DrawInk			;n`
	dec	a
	ld	(cur_y),a
	{
		call	CheckBlock	;Q`FbN
		jr	nc,break
		ld	a,(cur_y)
		inc	a
		ld	(cur_y),a
		ret
	}
	call	Sound1
	ret


_down:
	ld	a,(move_flg)		;_Œ͏㉺ړȂ
	or	a
	jr	nz,_left

	ld	a,(key)
	bit	KEY_2,a	
	jr	z,_left

	ld	a,(cur_y)
	cp	MAP_HEIGHT-1
	ret	nc

	call	DrawInk			;n`
	inc	a
	ld	(cur_y),a
	{
		call	CheckBlock	;Q`FbN
		jr	nc,break
		ld	a,(cur_y)
		dec	a
		ld	(cur_y),a
		ret
	}
	call	Sound1
	ret


_left:
	ld	a,(key)
	bit	KEY_4,a
	jr	z,_right

	ld	a,(cur_x)
	cp	1
	ret	c

	call	DrawInk			;n`
	dec	a
	ld	(cur_x),a
	{
		call	CheckBlock	;Q`FbN
		jr	nc,break
		ld	a,(cur_x)
		inc	a
		ld	(cur_x),a
		ret
	}
	call	Sound1
	ret


_right:
	bit	KEY_6,a
	ret	z

	ld	a,(cur_x)
	cp	MAP_WIDTH-4-1-1
	ret	nc

	call	DrawInk			;n`
	inc	a
	ld	(cur_x),a
	{
		call	CheckBlock	;Q`FbN
		jr	nc,break
		ld	a,(cur_x)
		dec	a
		ld	(cur_x),a
		ret
	}
	call	Sound1
	ret



;------------------------------------------------
;	J[\
;------------------------------------------------
PutCursor:
	call	GetCurPos
	ld	(hl),MARK_CUR		;LN^
	ret



;------------------------------------------------
;	n`
;------------------------------------------------
DrawInk:
	push	af

	call	GetCurPos
	{
		ld	a,(move_flg)
		or	a
		jr	nz,break

		ld	(hl),MARK_INK		;n
		pop	af
		ret
	}
	ld	(hl),0			;nuȂ
	pop	af
	ret



;------------------------------------------------
;	J[\̍W߂
;	out:	HL	}bvAhX
;------------------------------------------------
GetCurPos:
	ld	a,(cur_x)
	ld	b,a
	ld	a,(cur_y)
	add	a,a
	add	a,a
	add	a,a
	add	a,a		;~16
	add	a,b

	ld	e,a
	ld	d,0
	ld	hl,FieldMap
	add	hl,de
	ret



;------------------------------------------------
;	Q`FbN
;	out:	Cy=1	Q
;------------------------------------------------
CheckBlock:
	call	GetCurPos

	ld	a,(hl)
	or	a	;cp 0,Cy=0
	ret	z

	scf		;Cy=1
	ret



;------------------------------------------------
;	C
;------------------------------------------------
CheckLine:
	ld	hl,FieldMap
	ld	a,(cur_x)
	ld	e,a
	ld	d,0
	add	hl,de

	push	hl
	ld	bc,8*256+0
	{
		ld	a,(hl)
		or	a
		jr	z,break

		inc	c			;JEg
		{
			cp	MARK_BLOCK	;ubN܂ނ
			jr	nz,break
			inc	d		;ubNtO
		}
		push	bc
		ld	bc,MAP_WIDTH
		add	hl,bc

		pop	bc
		djnz	continue
	}
	pop	hl
	ld	a,c
	cp	8
	ret	nz
	call	ClearLine		;C

	ld	a,(erase_count)		;CJE^
	inc	a
	ld	(erase_count),a
	{
		ld	a,d			;ubN܂
		or	a
		jr	z,break
		{				;;;ubN܂ޏꍇ;;;
			ld	a,(chain_start)	;AJntO
			or	a
			jr	z,break		;0ȂXLbv

			call	CheckChain	;A`FbN
		}
		ld	a,1
		ld	(chain_start),a		;AJntOZbg

		call	AddScore		;XRAZ
		call	SetFlashMap
		call	Sound2
		ld	a,(chain_count)
		or	a
		ret	z
		call	Sound3
		jp	Sound3
	}
	xor	a			;;;ubN܂܂Ȃꍇ;;;
	ld	(chain_count),a		;AJEgZbg
	ld	(chain_start),a		;AJntOZbg
	call	SetFlashMap		;_ŃJEgZbg
	jp	Sound4
;	ret



;------------------------------------------------
;	PC
;	in:	HL	Cʒu
;------------------------------------------------
ClearLine:
	push	de
	ld	de,MAP_WIDTH
	ld	b,MAP_HEIGHT
	{
		ld	(hl),0
		add	hl,de
		djnz	continue
	}
	pop	de
	ret



;------------------------------------------------
;	_ŃJEgZbg
;------------------------------------------------
SetFlashMap:
	push	hl

	ld	hl,FlashMap
	ld	a,(cur_x)
	add	a,a
	ld	e,a
	ld	d,0
	add	hl,de

	ld	(hl),DEF_FLASH_COUNT	;_ŃJEg
	inc	hl
	ld	(hl),0			;LN^tO

	pop	hl
	ret



;------------------------------------------------
;	_ŏ
;------------------------------------------------
Flash:
	xor	a
	ld	(move_flg),a

	ld	hl,FlashMap
	ld	b,MAP_WIDTH
	ld	c,0				;XW
	{
		{
			ld	a,(hl)
			or	a
			jr	z,break
			dec	a		;JEg_E
			ld	(hl),a
			push	af
			{
				ld	a,(cur_x)
				sub	c
				jr	nz,break
				inc	a
				ld	(move_flg),a	;ړstO
			}
			pop	af
			call	DrawFlash	;_ŕ`
		}
		inc	hl
		inc	hl
		inc	c
		djnz	continue
	}
	ret



;------------------------------------------------
;	_ŕ`
;	in:	A	JEg
;		C	XW
;------------------------------------------------
DrawFlash:
	push_all
	inc	hl
	{
		and	0000_0111b	;8JEg
		jr	nz,break

		ld	a,(hl)
		xor	1		;tO]
		ld	(hl),a
	}
	ld	a,(hl)
	ld	hl,Chr_FLASH
	rlca
	rlca
	rlca				;tO~8
	ld	e,a
	ld	d,0
	add	hl,de

	ld	a,c
	add	a,a
	add	a,a
	add	a,a

	ld	e,a			;XW
	ld	a,(scrl_count)
	add	a,e
	ld	e,a			;XN[␳

	ld	d,0
	{
		ld	bc,8
		call	PutBitmap
		inc	d		;Y++
		ld	a,d
		cp	6
		jr	nz,continue
	}
	pop_all
	ret



;------------------------------------------------
;	A`FbN
;------------------------------------------------
CheckChain:
	ld	hl,FlashMap
	ld	b,MAP_WIDTH
	{
		ld	a,(hl)
		inc	hl
		inc	hl
		{
			or	a
			jr	z,break

			ld	c,a
			ld	a,(cur_x)
			cp	c
			jr	z,break

			ld	a,(chain_count)
			inc	a
			ld	(chain_count),a		;AJEg
			ret
		}
		djnz	continue
	}
	xor	a
	ld	(chain_count),a		;AJEgZbg
	ld	(chain_start),a		;AJntOZbg
	ret



;------------------------------------------------
;	ubÑXN[
;------------------------------------------------
ScrollBlock:
	ld	a,(scrl_wait)		;EFCg
	dec	a
	ld	(scrl_wait),a
	ret	nz

	ld	a,(scrl_wait_def)
	ld	(scrl_wait),a

	ld	a,(scrl_count)
	sub	1
	ld	(scrl_count),a		;hbgXN[̃JE^
	ret	nc

	ld	a,7
	ld	(scrl_count),a

	call	ScrollRight		;XN[
	call	ScrollErase
	call	ScrollErase

	ld	a,(cur_x)		;J[\XN[
	dec	a
	ld	(cur_x),a

	call	PutNewBlock		;VubN
	ret



;------------------------------------------------
;	PLN^XN[
;------------------------------------------------
ScrollRIght:
	ld	hl,FieldMap+1
	ld	de,FieldMap
	ld	bc,MAP_WIDTH*MAP_HEIGHT-1
	ldir
	ret


ScrollErase:
	ld	hl,FlashMap+1
	ld	de,FlashMap
	ld	bc,MAP_WIDTH*2-1
	ldir
	ret



;------------------------------------------------
;	}bvXN[֕`
;------------------------------------------------
MapToScreen:
	ld	c,MAP_HEIGHT
	ld	hl,FieldMap
	ld	d,0			;XYW
	ld	a,(scrl_count)		;XN[ʒu␳
	ld	e,a
	{
		ld	b,WIN_WIDTH/8	;12
		{
			ld	a,(hl)
			inc	hl
			{
				or	a	;XLbv
				jr	z,break

				push	hl
				ld	hl,Chr_data	;LN^f[^
				dec	a
				add	a,a
				add	a,a
				add	a,a	;A*8

				add	a,l
				ld	l,a
			        adc	a,h
			        sub	l
				ld	h,a		;add HL,A

				call	PutChr	;`
				pop	hl
			}
			ld	a,CHR_X_SIZE
			add	a,e
			ld	e,a		;add E,CHR_X_SIZE
			djnz	continue
		}
		ld	a,(scrl_count)
		ld	e,a			;X=(scrl_count)
		ld	a,CHR_Y_SIZE
		add	a,d
		ld	d,a			;add D,CHR_Y_SIZE

		inc	hl
		inc	hl
		inc	hl
		inc	hl			;add HL,4

		dec	c
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	XN[\@0-144
;------------------------------------------------
DispScreen:
	ld	hl,ScreenBuf
	jp	Send_LCDC
;	ret



;------------------------------------------------
;	EBhẼNA
;------------------------------------------------
ClearWindow:
	ld	hl,ScreenBuf+SCREEN_BLANK
	jp	ClearScreen
;	ret



;------------------------------------------------
;	ʉ
;------------------------------------------------
Sound1:
	;J[\ړ
	push_all
	ld	hl,440
	ld	de,8
	call	Beep
	ld	hl,580
	ld	de,16
	call	Beep

	pop_all
	ret

	;C,Q[X^[g
Sound2:
	push_all
	ld	hl,420
	ld	de,8
	call	Beep
	ld	hl,280
	ld	de,12
	call	Beep

	ld	hl,360
	ld	de,12
	call	Beep
	ld	hl,200
	ld	de,18
	call	Beep

	pop_all
	ret

	;CA
Sound3:
	push_all
	ld	hl,380
	ld	de,8
	call	Beep
	ld	hl,200
	ld	de,12
	call	Beep

	ld	hl,320
	ld	de,12
	call	Beep
	ld	hl,180
	ld	de,18
	call	Beep

	pop_all
	ret

	;C_
Sound4:
	push_all
	ld	hl,700
	ld	de,8
	call	Beep
	ld	hl,400
	ld	de,16
	call	Beep

	pop_all
	ret

	;Q[I[o[
Sound5:
	push_all
	ld	hl,1400
	ld	de,20
	call	Beep
	ld	hl,1900
	ld	de,40
	call	Beep

	pop_all
	ret

	;xAbv
Sound6:
	push_all
	ld	hl,180
	ld	de,10
	call	Beep
	ld	hl,120
	ld	de,10
	call	Beep

	pop_all
	ret



;------------------------------------------------
;	XRA
;------------------------------------------------
InitScore:
	xor	a
	ld	(score),a
	ld	(score+1),a
	ld	(score+2),a
	ret


InitHiscore:
	xor	a
	ld	(hiscore),a
	ld	(hiscore+1),a
	ld	(hiscore+2),a
	ret



;------------------------------------------------
;	XRA\
;------------------------------------------------
DispScore:
	ld	hl,score
	ld	de,3*256+108		;108,3
	jp	PutBCD3			;U\
;	ret



;------------------------------------------------
;	nCXRA\
;------------------------------------------------
DispHiScore:
	ld	hl,hiscore
	ld	de,1*256+108		;108,1
	jp	PutBCD3
;	ret



;------------------------------------------------
;	x\
;------------------------------------------------
DispLv:
	ld	hl,level
	ld	de,5*256+108		;108,5
	jp	PutBCD			;Q\
;	ret



;------------------------------------------------
;	XRAZ
;------------------------------------------------
AddScore:
	push_all
	ld	a,(chain_count)		;AJEg
	inc	a
	ld	b,a
	{
		ld	hl,score+2
		ld	a,10h			;+10_

		add	a,(hl)
		daa
		ld	(hl),a
		dec	hl

		ld	a,0
		adc	a,(hl)
		daa
		ld	(hl),a
		dec	hl

		ld	a,0
		adc	a,(hl)
		daa
		ld	(hl),a

		djnz	continue
	}
	call	DispScore
	pop_all
	ret



;------------------------------------------------
;	nCXRAL^
;------------------------------------------------
CmpHiscore:
	ld	hl,hiscore+2

	ld	de,score+2
	ld	a,(de)
	dec	de

	sub	(hl)
	dec	hl

	ld	a,(de)
	dec	de

	sbc	(hl)
	dec	hl

	ld	a,(de)
	sbc	(hl)

	ret	c

	ld	a,(score)
	ld	(hiscore),a
	ld	a,(score+1)
	ld	(hiscore+1),a
	ld	a,(score+2)
	ld	(hiscore+2),a

	ret



;------------------------------------------------
;	o[W\
;------------------------------------------------
InfoVer_GAME:
	ld	hl,_g_ver
	ld	de,0000h		;X=0,Y=0
	ld	b,_g_end-_g_ver
	call	SYS_PUT_STRING
	ret


_g_ver:
	db	'HITOFUDE 1.01'
_g_end:



	include	"LIB.ASM"		;Cu
	include "DATA.ASM"		;f[^
	include	"WORK.ASM"		;[NGA



	end
	